<?php
class DevBB_News
{
    // Non-Editable
    var $fid;
    var $header;
    var $version = '1.20';

    // Editable
    var $num_headlines = 10; // Number of headlines to show.
    var $num_news      = 20; // Number of news post to show.

    /**
     * Constructor
     */
    function DevBB_News($fid)
    {
        $this->header = "\n<!-- Powered By DevBB News v$this->version -->\n";

        if(isset($fid))
        {
            if(strstr($fid, ','))
            {
                $fids = explode(',', $fid);
                
                while( list($foo, $id) = each($fids) )
                {
                    $this->fid[] = intval(trim($id));
                }
                reset($this->fid);
            }
            else
            {
                $this->fid = intval($fid);
            }
        }
        else
        {
            $this->messsage_die("DevBB_News->DevBB_News(): You must set the forum ID of you news forum.");
        }
    }
    /**
     * Shows X number of headlines from devbb news forum
     *
     * @param integer number of headlines to show, if not set default will be used.
     *
     */
    function headlines($num = -1)
    {
        global $db, $devbb_var;
        global $table_threads, $table_posts;

        if($num != -1)
        {
            $this->num_headlines = intval($num);
        }
        
        if( is_array($this->fid) )
        {
            while( list($foo, $id) = each($this->fid) )
            {
                $fid_sql .= " t.fid = $id OR";
            }
            reset($this->fid);
            
            $fid_sql = substr($fid_sql, 0, strlen($fid_sql) - 2);
        }
        else
        {
            $fid_sql = " t.fid = $this->fid";
        }

        $headline_sql = "SELECT t.tid, t.subject FROM $table_threads t LEFT JOIN $table_posts p ON (t.tid = p.tid AND t.subject = p.subject) WHERE $fid_sql ORDER BY p.pid DESC LIMIT 0,$this->num_headlines";

        $result = $db->query($headline_sql);

        if(!$result)
        {
            $this->messsage_die("DevBB_News->headlines(): Could not obtain headlines data.");
        }

        while( $headline = $db->fetch_array($result) )
        {
            eval("\$output .= \"" . template('devbb_news_headline_bit') . "\";");
        }
        
        $output = preg_replace("#<!--Begin Template: (.*?) -->\n#", "", $output);
        $output = preg_replace("#\n<!-- End Template: (.*?) -->#", "", $output);
        
        return $this->header . $output;
    }
    /**
     * Returns X number of news items from devbb news forum
     *
     * @param integer number of news items to show, if not set default will be used.
     *
     */
    function news($num = -1)
    {
        global $db, $devbb_var;
        global $table_threads, $table_posts, $table_members;

        if($num != -1)
        {
            $this->num_news = intval($num);
        }
        
        if( is_array($this->fid) )
        {
            while( list($foo, $id) = each($this->fid) )
            {
                $fid_sql .= " t.fid = $id OR";
            }
            reset($this->fid);

            $fid_sql = substr($fid_sql, 0, strlen($fid_sql) - 2);
        }
        else
        {
            $fid_sql = " t.fid = $this->fid";
        }

        $news_sql = "SELECT t.tid, t.subject, p.message, t.author, m.email, p.dateline, m.timeoffset, t.replies as comments FROM $table_threads t LEFT JOIN $table_posts p ON (t.tid = p.tid AND t.subject = p.subject) LEFT JOIN $table_members m ON (t.author = m.username) WHERE $fid_sql ORDER BY p.pid DESC LIMIT 0,$this->num_news";
        
        $result = $db->query($news_sql);

        if(!$result)
        {
            $this->messsage_die("DevBB_News->news(): Could not obtain news data.");
        }

        while( $news = $db->fetch_array($result) )
        {
            $news['message'] = str_replace("\n", "<br />\n", stripslashes(str_replace("\r", "", $news['message'])));
            $news['date'] = gmdate($devbb_var['date_format'], $news['dateline'] + ($news['timeoffset'] * 3600));
            $news['time'] = gmdate($devbb_var['time_format'], $news['dateline'] + ($news['timeoffset'] * 3600));

            eval("\$output .= \"" . template('devbb_news_bit') . "\";");
        }
        
        if( strstr($output,'[') && strstr($output,']') )
        {
            $output = preg_replace("#\[b\](.*?)\[/b\]#si","<b>\\1</b>",$output);
            $output = preg_replace("#\[i\](.*?)\[/i\]#si","<i>\\1</i>",$output);
            $output = preg_replace("#\[u\](.*?)\[/u\]#si","<u>\\1</u>",$output);
            $output = preg_replace("#\[img\](.*?)\[/img\]#si","<img src=\"\\1\" border=\"0\" />",$output);
        }
        
        $output = preg_replace("#<!--Begin Template: (.*?) -->\n#", "", $output);
        $output = preg_replace("#\n<!-- End Template: (.*?) -->#", "", $output);
        
        return $this->header . $output;
    }
    /**
     * Small error function, kills the script process with an ugly message :0
     *
     * @param string detailed error message
     *
     */
    function messsage_die($msg)
    {
        $message = "The has been an error.<br />\nDetails: $msg";
        die($message);
    }
}
?>
